// main.cpp
//

#include "PursuitDrift.h"

#define SETTINGSSAVETEST

PCSettings settings;
PRCamera camera;

int WINAPI WinMain(HINSTANCE hInstance, HINSTANCE hPrevInstance, LPSTR lpCmdLine, int nShowCmd)
{
#ifdef SETTINGSSAVETEST
	PCSettings p;
	ZeroMemory(&p, sizeof(PCSettings));
	p.fullscreen = FALSE;
	p.adapterno = 0;
	p.modeno = 5;
	p.devicetype = D3DDEVTYPE_HAL;
	p.multisampletype = D3DMULTISAMPLE_NONE;
	p.multisamplequality = 0;
	p.deviceflags = D3DCREATE_HARDWARE_VERTEXPROCESSING;
	PCSaveSettings(p);
#endif

	HWND hWnd;
	WNDCLASSEX wc;
	MSG msg;

	memset(&wc, 0, sizeof(WNDCLASSEX));
	memset(&msg, 0, sizeof(MSG));

	PCLoadSettings(&settings);

	wc.cbSize = sizeof(WNDCLASSEX);
	wc.style = CS_HREDRAW | CS_VREDRAW;
	wc.hInstance = hInstance;
	wc.hIcon = LoadIcon(hInstance, TEXT("IDI_PDICON"));
	wc.lpfnWndProc = WindowProc;
	wc.lpszClassName = WNDCLSNAME;

	RegisterClassEx(&wc);

	D3DDISPLAYMODE displaymode;
	PRGetAdapterMode(settings, &displaymode);

	hWnd = CreateWindowEx(NULL,
						  WNDCLSNAME,
						  TEXT("PursuitDrift"),
						  WS_OVERLAPPEDWINDOW,
						  CW_USEDEFAULT,
						  CW_USEDEFAULT,
						  displaymode.Width,
						  displaymode.Height,
						  NULL,
						  NULL,
						  hInstance,
						  NULL);

	ShowWindow(hWnd, nShowCmd);
	UpdateWindow(hWnd);

	PDRESULT dxinit = PRInitDxDevice(hWnd, settings);
	PDRESULT diinit = PIInit(hWnd, settings);
	PDRESULT nxinit = PPInitPhysics(settings);

	if (PDFAILED(dxinit) || PDFAILED(diinit) || PDFAILED(nxinit))
	{
		exit(EXIT_FAILURE);
	}

	PRSMInit();

	camera = PRCamera();

	DWORD dwStart;
	DWORD dwStop;
	float fDelta = 0.0f;

	while (TRUE)
	{
		// Startpunkt messen
		dwStart = GetTickCount();

		// Windows Nachrichten verarbeiten
		while (PeekMessage(&msg, NULL, 0, 0, PM_REMOVE))
		{
			DispatchMessage(&msg);
			TranslateMessage(&msg);
		}

		// Sollte die Nachricht WM_QUIT sein, mssen wir aufhren!
		if (msg.message == WM_QUIT)
			break;

		PDRenderGame(fDelta);
		PDUpdateGame(fDelta);
		PRPresent();
		
		// Endzeit
		dwStop = GetTickCount();

		// Unterschied ausrechnen
		fDelta = (float)(dwStop - dwStart) / 1000.0f;
	}

	return msg.wParam;
}

LRESULT CALLBACK WindowProc(HWND hWnd, 
							UINT msg,
							WPARAM wParam,
							LPARAM lParam)
{
	switch (msg)
	{
	case WM_CREATE:
		break;
	case WM_SIZE:
		
		break;
	case WM_TIMER:
		PIUpdateKeyboard(hWnd);
		break;
	case WM_DESTROY:
		PPReleasePhysics();
		PIRelease();
		PRRelease();
		PostQuitMessage(EXIT_SUCCESS);
		break;
	}

	return DefWindowProc(hWnd, msg, wParam, lParam);
}
