// PRCamera.h

#ifndef _PR_CAMERA_H
#define _PR_CAMERA_H

class PRENDER_API PRCamera
{
public:
	PRCamera(void);
	~PRCamera(void);

	void Update(float deltatime);

	// Get/Set
	float GetNearPlane(void);
	float GetFarPlane(void);

	void SetNearPlane(float v);
	void SetFarPlane(float v);

private:
	void calculateViewProj(void);

	float xrot; // Rechts-Links Rotation
	float yrot; // Oben-Unten Rotation

	D3DXMATRIX projMatrix;
	D3DXMATRIX viewMatrix;

	D3DXVECTOR3 position;

	float nearPlane;
	float farPlane;
};

#endif