using Microsoft.Xna.Framework;

namespace PursuitDrift.Interfaces.GameObjects
{
    /// <summary>
    /// Vorlage fr eine Kamera.
    /// </summary>
    public interface ICamera
    {
        /// <summary>
        /// Gibt die aktuelle View zurck.
        /// </summary>
        Matrix View { get; set; }

        /// <summary>
        /// Gibt die aktuelle Projection zurck.
        /// </summary>
        Matrix Projection { get; set; }

        /// <summary>
        /// Gibt die aktuelle View, multipliziert mit der 
        /// Projection, zurck.
        /// </summary>
        Matrix ViewProjection { get; }

        /// <summary>
        /// Gibt die nahste abgebildete Distanz zurck, oder 
        /// legt diese fest.
        /// </summary>
        float NearPlaneDistance { get; set; }

        /// <summary>
        /// Gibt die weiteste abgebildete Distanz zurck, 
        /// oder legt diese fest.
        /// </summary>
        float FarPlaneDistance { get; set; }

        /// <summary>
        /// Gibt den AspectRatio, die Breite des Fensters geteilt 
        /// durch die Hhe des Fensters, zurck, oder legt diese fest.
        /// </summary>
        float AspectRatio { get; set; }

        /// <summary>
        /// Gibt den FieldOfView zurck, oder legt diesen fest.
        /// </summary>
        float FieldOfView { get; set; }
    }
}